

{

Sync 'Em!
by Antti Kirjavainen
akirjavainen@mail.htk.fi

A program to synchronize your system time
and all the other computers in the network.

You can do what you like with this code,
but you may NOT publish it as another program.

}


program SyncTime;

{$APPTYPE CONSOLE}

uses
  SysUtils,
  QForms,
  IdBaseComponent,
  IdComponent,
  IdTCPConnection,
  IdTCPClient,
  IdTimeServer;

const
  ENTER = Chr(13) + Chr(10);

var
  idTimeSrv: TidTimeServer;
  Port: Integer;
  CMDCommand: String;


function InStr(const sData, sFind: string): integer; overload;
begin
  result := Pos(sFind, sData);
end;

function InStr(nStart: integer; const sData, sFind: string): integer; overload;
var
  sTemp : String;
  nFound: integer;
begin
  sTemp  := Copy(sData, nStart, Length(sData) - (nStart - 1));
  nFound := Pos(sFind, sTemp);
  if nFound = 0 then
    result := 0
  else
    result := nFound + nStart - 1;
end;

function MidStr(const pString, pAbre, pFecha: String; pInclui: boolean): string;
var
  lIni, lFim : integer;
begin
  if (pInclui = False) then begin
    lIni := Pos(UpperCase(pAbre), UpperCase(pString)) + Length(pAbre);
    lFim := InStr(lIni, UpperCase(pString), UpperCase(pFecha));
  end else begin
    lIni := Pos(UpperCase(pAbre), UpperCase(pString));
    lFim := InStr(lIni + Length(pAbre), UpperCase(pString), UpperCase(pFecha)) + Length(pFecha);
  end;
  result := Copy(pString, lIni, lFim - lIni);
end;

procedure ProcessCommand(UserCommand : String);
var
        tmpPort : Integer;

begin

UserCommand := UpperCase(UserCommand);

if (Length(UserCommand) > 0) then begin
                                 if (Pos('HELP', UserCommand) > 0) or (UserCommand = '?') then begin
                                                                Writeln('');
                                                                Writeln('Commands:');
                                                                Writeln('HELP = This help screen');
                                                                Writeln('PORT = Change port. Parameters = port.');
                                                                Writeln('EXIT = Terminate the program');
                                                                Application.Terminate();
                                                                end;
                                 if (Pos('PORT', UserCommand) > 0) then begin
                                                                try
                                                                        tmpPort := StrToInt(copy(UserCommand, Pos(' ', UserCommand) + 1, Length(UserCommand) - Pos(' ', UserCommand)));

                                                                        Port := tmpPort;
                                                                        idTimeSrv.Active := False;
                                                                        idTimeSrv.Free;

                                                                        idTimeSrv := TidTimeServer.Create(Application); 
                                                                        idTimeSrv.DefaultPort := Port;
                                                                        idTimeSrv.Active := True;
                                                                        Writeln('Port changed to ' + IntToStr(Port) + '.');
                                                                except
                                                                        idTimeSrv.Active := True;
                                                                        Writeln('Invalid port, or port could not be opened.');
                                                                end;
                                                                end;
                                 if (Pos('EXIT', UserCommand) > 0) or (Pos('QUIT', UserCommand) > 0) then begin
                                                                Writeln('Server stopped by user.');
                                                                Writeln('');
                                                                idTimeSrv.Active := False;
                                                                idTimeSrv.Free;
                                                                Application.Terminate;
                                                                exit;
                                                                end;

                                 end;

Writeln('');
Write('> ');
Readln(UserCommand);
ProcessCommand(UserCommand);
end;

procedure PauseProgram;
// Pause the program with Readln:
var
  Pause : String;

begin
Writeln('');
Writeln('Press any key to quit...');
Readln(Pause);
end;

begin

  Writeln('');
  Writeln('Sync ''Em! v2.1');
  Writeln('by Antti Kirjavainen');
  Writeln('');
  Writeln('akirjavainen@mail.htk.fi');
  Writeln('http://www.htk.fi/public/akirjavainen');
  Writeln('');
  Writeln('');

  Port := 37;


  // Get the command line parameters:
  CMDCommand := ParamStr(1);
  if (Pos('-?', CMDCommand) > 0) or (Pos('-H', CMDCommand) > 0) then begin
                                        Writeln('Command line parameters for Sync ''Em! daemon: ' + ENTER + ENTER + '[port] = Port to use' + ENTER + '-? = This help screen' + ENTER + ENTER + 'Time Synchronization (NTP) server.');
                                        Writeln('');
                                        Application.Terminate;
                                        exit;
                                        end;
  if (Length(CMDCommand) > 0) then Port := StrToIntDef(CMDCommand, 37);


// Create the component:
try
  idTimeSrv := TidTimeServer.Create(Application);
  idTimeSrv.DefaultPort := Port;

  idTimeSrv.Active := True;
  Writeln('Time server started on port ' + IntToStr(Port) + '.');
  Writeln('Enter ? for list of commands.');
  ProcessCommand('');
except
  Writeln('Could not start the server!');
end;

end.
